SystemOrganization addCategory: #SyncRepo!

Object subclass: #RepositoryToSync
	instanceVariableNames: 'repository sync'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SyncRepo'!

!RepositoryToSync methodsFor: 'operations' stamp: 'hjo 6/20/2012 22:19'!
copyFilesTo: copyTarget

	(self files copyWithoutAll: copyTarget files)
		do: 
			[:each| |version| 
				version := self repository loadVersionFromFileNamed: each. 
				version isNil
					ifTrue: [Transcript cr; nextPutAll: '#loadVersionFromFileNamed: failed. The argument was '; print: each; flush]
					ifFalse: [copyTarget repository storeVersion: version]
			 ]
		displayingProgress: [:each| 'Copying ', each].! !

!RepositoryToSync methodsFor: 'accessing' stamp: 'hjo 6/20/2012 22:19'!
files

	^repository allFileNames select: [:each| sync willSyncTheFile: each ].! !

!RepositoryToSync methodsFor: 'accessing' stamp: 'hjo 4/27/2012 20:35'!
repository
	^ repository! !

!RepositoryToSync methodsFor: 'accessing' stamp: 'hjo 4/27/2012 20:35'!
repository: aMCRepository
	repository := aMCRepository
! !

!RepositoryToSync methodsFor: 'accessing' stamp: 'hjo 4/27/2012 20:39'!
sync
	^ sync! !

!RepositoryToSync methodsFor: 'accessing' stamp: 'hjo 4/27/2012 20:39'!
sync: aSyncRepo
	sync := aSyncRepo
! !

Object subclass: #SyncRepo
	instanceVariableNames: 'packageNames repos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SyncRepo'!

!SyncRepo class methodsFor: 'instance creation' stamp: 'hjo 4/27/2012 22:56'!
repository: repo1 repository: repo2 

	^self new 
		addRepository: repo1;
		addRepository: repo2;
		syncRepos.! !

!SyncRepo class methodsFor: 'instance creation' stamp: 'hjo 4/27/2012 22:57'!
repository: repo1 repository: repo2 packageNames: anArray

	^self new 
		addRepository: repo1;
		addRepository: repo2;
		packageNames: anArray;
		syncRepos.! !

!SyncRepo class methodsFor: 'instance creation' stamp: 'hjo 4/27/2012 22:57'!
repository: repo1 repository: repo2 stringOfPackageNames: aString

	^self new 
		addRepository: repo1;
		addRepository: repo2;
		packageNames: aString subStrings;
		syncRepos.! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 7/17/2012 22:48'!
shareAll

	self 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/Dropbox/package-daliotMade')) 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/Dropbox/package-daliotMade2'))! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 7/17/2012 22:48'!
shareAni

	self 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/Dropbox/package-daliotMade')) 
		repository: (MCHttpRepository location: 'http://www.squeaksource.com/DaliotsPlayground' user: '' password: '') 
		stringOfPackageNames: 'LazyRabbit LazyRabbitOmniBrowser Daliot SortDescriptors Ani ConfigurationOfDaliotsPlayground'.! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 8/1/2012 11:48'!
shareDaliotsPlayground

	^self new 
		addRepository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/Dropbox/package-daliotMade')) ;
		addRepository:  (MCHttpRepository location: 'http://www.squeaksource.com/DaliotsPlayground' user: '' password: '');
		addPackageNamed: 'Ani';
		addPackageNamed: 'AppleScriptProgrammer';
		addPackageNamed: 'AniOmniBrowser';
		addPackageNamed: 'BinarySearch';
		addPackageNamed: 'BloodType';
		addPackageNamed: 'ConfigurationOfDaliotsPlayground';
		addPackageNamed: 'CopyHierarchy';
		addPackageNamed: 'Daliot';
		addPackageNamed: 'DaliotsMappers';
		addPackageNamed: 'DefragFAT';
		addPackageNamed: 'DependencySorter';
		addPackageNamed: 'DevPacerCommon';
		addPackageNamed: 'DevPacerPharo12';
		addPackageNamed: 'DevPacerPharo13';
		addPackageNamed: 'DevPacerPharo14';
		addPackageNamed: 'DijEvolution';
		addPackageNamed: 'DrillDownMethodSearch';
		addPackageNamed: 'Graph';
		addPackageNamed: 'HangmanRescue';
		addPackageNamed: 'ImageFamilyTree';
		addPackageNamed: 'ImageFootprint';
		addPackageNamed: 'InteractiveBisect';
		addPackageNamed: 'Jihachol';
		addPackageNamed: 'LazyRabbit';
		addPackageNamed: 'LazyRabbitOmniBrowser';
		addPackageNamed: 'MaxClub';
		addPackageNamed: 'MobienceIPhoneProject';
		addPackageNamed: 'MorphoPhysics';
		addPackageNamed: 'MultiDimensionalEnumeration';
		addPackageNamed: 'MultiQuoAndRem';
		addPackageNamed: 'PhileasFogg';
		addPackageNamed: 'PocketCube';
		addPackageNamed: 'Range';
		addPackageNamed: 'Roulette';
		addPackageNamed: 'SketchupRuby';
		addPackageNamed: 'SmalltalkQuiz';
		addPackageNamed: 'SortDescriptors';
		addPackageNamed: 'SourceCodeTourGuideCommon';
		addPackageNamed: 'SourceCodeTourGuideOmniBrowser';
		addPackageNamed: 'SourceCodeTourGuidePharo12';
		addPackageNamed: 'SourceCodeTourGuidePharo13';
		addPackageNamed: 'SourceCodeTourGuidePharo14';
		addPackageNamed: 'StatPseudoCollections';
		addPackageNamed: 'StatisticalObjects';
		addPackageNamed: 'TechnologyTreeOptimizationOfTheCivilizationRevolution';
		addPackageNamed: 'TestableGraphics';
		addPackageNamed: 'ToolDad';
		addPackageNamed: 'UndoRedo';
		addPackageNamed: 'WoodCutPictures';
		syncRepos.! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 7/17/2012 22:49'!
shareDevPacer

	^self new 
		addRepository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/Dropbox/package-daliotMade')) ;
		addRepository:  (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/DropBox/DevPacer'));
		addRepository:  (MCHttpRepository location: 'http://www.squeaksource.com/DaliotsPlayground' user: '' password: '');
		packageNames: 'Ani AniOmniBrowser Daliot LazyRabbit LazyRabbitOmniBrowser DevPacerCommon DevPacerPharo12 DevPacerPharo13 DevPacerPharo14 DevPacerPharo20 SortDescriptors' subStrings;
		syncRepos.! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 7/17/2012 22:49'!
shareMe

	self 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/Dropbox/package-daliotMade')) 
		repository: (MCHttpRepository location: 'http://ss3.gemstone.com/ss/SyncRepo' user: 'hjo' password: '') stringOfPackageNames: 'SyncRepo'.! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 7/17/2012 22:49'!
shareSourceCodeTourGuide

	self 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/Dropbox/package-daliotMade')) 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/DropBox/SourceCodeTourGuide')) stringOfPackageNames: 
		'Ani Daliot DrillDownMethodSearch LazyRabbit SortDescriptors SourceCodeTourGuide SourceCodeTourGuideOmniBrowser SourceCodeTourGuidePharo12 SourceCodeTourGuidePharo13 SourceCodeTourGuidePharo14'.! !

!SyncRepo methodsFor: 'accessing' stamp: 'hjo 6/12/2012 07:49'!
addPackageNamed: aString 
	
	self packageNames add: aString.! !

!SyncRepo methodsFor: 'accessing' stamp: 'hjo 4/27/2012 22:58'!
addRepository: anMCRepository

	repos add: (RepositoryToSync new  repository: anMCRepository; sync: self).! !

!SyncRepo methodsFor: 'initialize-release' stamp: 'hjo 4/27/2012 22:58'!
initialize

	super initialize.
	repos := OrderedCollection new.! !

!SyncRepo methodsFor: 'accessing' stamp: 'hjo 6/12/2012 07:50'!
packageNames

	packageNames isNil ifTrue: [
		packageNames := OrderedCollection new.
		].
	^packageNames! !

!SyncRepo methodsFor: 'accessing' stamp: 'hjo 4/15/2012 10:56'!
packageNames: strings

	packageNames := strings.! !

!SyncRepo methodsFor: 'accessing' stamp: 'hjo 6/12/2012 07:51'!
stringOfPackageNames: aString

	packageNames := nil.
	self packageNames addAll: aString subStrings.! !

!SyncRepo methodsFor: 'operation' stamp: 'hjo 7/27/2012 16:29'!
syncRepos

	| syncOrders |
	syncOrders := (repos allButLast), (repos reverse).
	(1 to: syncOrders size-1) 
		do: 
			[:index| |source target|
				source := syncOrders at: index.
				target := syncOrders at: index+1.
				source copyFilesTo: target.
			]
		displayingProgress: [:index|
			'Syncing Repositories ', index printString, '/', (syncOrders size-1) printString].! !

!SyncRepo methodsFor: 'testing' stamp: 'hjo 6/12/2012 07:50'!
willSyncTheFile: aString

	self packageNames isNil ifTrue: [^true].
	self packageNames isEmpty ifTrue: [^true].
	^self packageNames anySatisfy: [:each| aString beginsWith: each , '-' ] .! !
